package experimentalcode.tobias.TrigonometricPruning;

import java.util.TreeMap;

import de.lmu.ifi.dbs.elki.database.ids.DBID;
import de.lmu.ifi.dbs.elki.distance.distancefunction.EuclideanDistanceFunction;
import experimentalcode.tobias.TrigonometricPruning.structures.DataBall;
import experimentalcode.tobias._index.helpstructures.KNNList;
import experimentalcode.tobias._index.sstree.DoubleVector;

public abstract class AkNNJoin {
  
  int distanceCalculations;
  int logicalPageAccesses;
  int physicalPageAccesses;
  EuclideanDistanceFunction edf = EuclideanDistanceFunction.STATIC;
  
  public abstract TreeMap<DBID,KNNList<DoubleVector>> join(DataBall queryBall, int k);
  
  public void addResult(DoubleVector query, DoubleVector potentialNeighbor, int k, TreeMap<DBID,KNNList<DoubleVector>> aknnJoinResult){
    double dist = (edf.distance(query, potentialNeighbor).getValue());
    distanceCalculations++;
    if(aknnJoinResult.containsKey(query.getID())){
      KNNList knnList = aknnJoinResult.get(query.getID());
      knnList.add(potentialNeighbor, dist);
    }else{
      KNNList knnList = new KNNList(k); 
      knnList.add(potentialNeighbor, dist);
      
      aknnJoinResult.put(query.getID(), knnList);
    }
  }
  
  
  @Override
  public String toString(){
    String s = "";
    s += "DistanceCalculations: "+distanceCalculations+"\n";
    s += "logical PageAccesses: "+logicalPageAccesses+"\n";
    s += "physical PageAccesses: "+physicalPageAccesses+"\n";
    return s;
  }
}
