package experimentalcode.tobias.TrigonometricPruning.structures;

import java.util.List;

import de.lmu.ifi.dbs.elki.data.HyperBoundingBox;
import de.lmu.ifi.dbs.elki.distance.distancefunction.EuclideanDistanceFunction;
import experimentalcode.tobias._index.sstree.DoubleVector;

public class DataBall{
		public List<DoubleVector> objects;
		public DoubleVector center;
		public double radius;
		EuclideanDistanceFunction df = EuclideanDistanceFunction.STATIC;
		
		public DataBall(List<DoubleVector> obj, DoubleVector c){
			center = c;
			objects = obj;
			for(DoubleVector o:obj){
				radius = Math.max(radius,df.distance(o, c).getValue());
			}
		}
		public DataBall(List<DoubleVector> obj, DoubleVector c, double r){
			center = c;
			objects = obj;
			radius = r;
		}
		public DataBall(List<DoubleVector> obj){
			int dim = obj.get(0).getDimensionality();
			double[] center = new double[dim];
			for(DoubleVector o:obj){
				for(int d = 0; d< dim;d++){
					center[d] += o.getValue(d+1);
				}
			}
			for(int d = 0; d< dim;d++){
				center[d] /= obj.size();
			}
			this.center = new DoubleVector(center);
			objects = obj;
			for(DoubleVector o:obj){
				radius = Math.max(radius, df.distance(o, this.center).getValue());
			}
		}
		public HyperBoundingBox getMBR(){
		  double[] min = new double[center.getDimensionality()];
		  for(int i = 0; i< min.length;i++){
		    min[i] = Double.MAX_VALUE;
		  }
		  double[] max = new double[center.getDimensionality()];
		  
		  for(DoubleVector dv: objects){
		    for(int d = 0; d < dv.getDimensionality();d++){
		      min[d] = Math.min(min[d], dv.getValue(d+1));
		      max[d] = Math.max(max[d], dv.getValue(d+1));
		    }
		  }
		  return new HyperBoundingBox(min, max);
		}
}
