package experimentalcode.tobias.TrigonometricPruning.utils;

import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.TreeMap;
import java.util.Map.Entry;

import de.lmu.ifi.dbs.elki.database.ids.DBID;
import de.lmu.ifi.dbs.elki.distance.distancefunction.EuclideanDistanceFunction;
import experimentalcode.tobias._index.helpstructures.KNNList;
import experimentalcode.tobias._index.sstree.DoubleVector;

public class Compare {

  public static void compareResults(TreeMap<DBID, KNNList<DoubleVector>> save, TreeMap<DBID, KNNList<DoubleVector>> unsave) {
    Set<Entry<DBID, KNNList<DoubleVector>>> set = save.entrySet();
    Iterator<Entry<DBID, KNNList<DoubleVector>>> iter = set.iterator();
    boolean right = true;
    while(iter.hasNext()) {
      Entry<DBID, KNNList<DoubleVector>> entry = iter.next();
      DBID queryKey = entry.getKey();
      double knnDist = entry.getValue().getKNNdist();
      if(!unsave.containsKey(queryKey)) {
        System.out.println("Missing key: " + queryKey);
        right = false;
        continue;
      }
      else {
        KNNList<DoubleVector> unsavepq = unsave.get(queryKey);
        if(knnDist != unsavepq.getKNNdist()) {
          System.out.println("---->Query: " + queryKey + "has wrong result - " + unsavepq.getKNNdist() + " / " + knnDist);
          right = false;
        }
      }
    }
    if(right)
      System.out.println("stimmt überein");
  }

  public static TreeMap<DBID, KNNList<DoubleVector>> bruteForceKnn(List<DoubleVector> outerSet, List<DoubleVector> innerSet, int k) {
    TreeMap<DBID, KNNList<DoubleVector>> result = new TreeMap<DBID, KNNList<DoubleVector>>();
    EuclideanDistanceFunction edf = EuclideanDistanceFunction.STATIC;
    for(DoubleVector outer : outerSet) {
      KNNList<DoubleVector> knns = new KNNList<DoubleVector>(k);
      for(DoubleVector inner : innerSet) {
        knns.add(inner, edf.distance(inner, outer).getValue());
      }
      result.put(outer.getID(), knns);
    }
    return result;
  }
}
