package experimentalcode.tobias._index.sstree;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.PriorityQueue;

import de.lmu.ifi.dbs.elki.distance.distancefunction.EuclideanDistanceFunction;

public class SSTreeTest {
	public static void main(String args[]) throws NumberFormatException, IOException{
		int k = 10;
		System.out.println("Reading data");
		List<DoubleVector> data = null;//CSVutils.readCSV("experimentalcode/tobias/data/Cluster50000-2.csv");
		System.out.println("Building Tree");
		SSTree<DoubleVector> sstree = new SSTree<DoubleVector>(10,30, 10);
		
		for(int i = 0; i< data.size();i++){
			sstree.insert(data.get(i));
		}
		System.out.println(sstree.toString());
		System.out.println("Querying");
		EuclideanDistanceFunction df = EuclideanDistanceFunction.STATIC;
		for(int q = 0; q< 50;q++){
			//exact solution
			PriorityQueue<DistanceObjectTuple> pq = new PriorityQueue<DistanceObjectTuple>();
			for(int i = 0; i< data.size();i++){
				pq.add(new DistanceObjectTuple(df.distance(data.get(i), data.get(q)).getValue(), data.get(i)));
			}
			List<DoubleVector> res1 = new ArrayList<DoubleVector>();
			for(int i = 0; i< k;i++){
				res1.add((DoubleVector)(pq.poll().object));
			}
			//sstree
			//List<DoubleVector> res2 = sstree.kNNQuery(data.get(q), k);
			sstree.reset();
			for(int i = 0; i< k;i++){
				if(res1.get(i).getID() != sstree.getNext(data.get(q)).getID())
					System.out.println("Query: "+q+" position:" +i);
			}
		}
		System.out.println("Done: No outputs => nor errors");
		
	}
}
