package experimentalcode.tobias.rknnjoin.structures;

import java.util.ArrayList;

import de.lmu.ifi.dbs.elki.index.tree.spatial.SpatialEntry;

public class QueueObject implements Comparable<QueueObject>{ 
    public double rankingCount;
    public double minDist;
    public SpatialEntry entry;
    public ArrayList<QueueObject> update1, //elemente die im Schlauch von entry und q liegen
    						update2; //elemente in dessen Schlauch (e'' und q) entry liegt
    public boolean selfPruned;
    
    public QueueObject(SpatialEntry entry, double rankingCount) {
        this.entry=entry;
        this.rankingCount=rankingCount;
        update1 = new ArrayList<QueueObject>();
        update2 = new ArrayList<QueueObject>();
        selfPruned = false;
    }

    public int compareTo(QueueObject target) {
        if (this.rankingCount<target.rankingCount) return -1;
        else if (this.rankingCount>target.rankingCount) return 1;
        else{
        	if (this.minDist < target.minDist) return -1;
        	else if (this.minDist>target.minDist) return 1;
        	else return 0;
        }
    }
    /**
     * clones the object (it's score, entry and the two updatelists but not the objects in them)
     */
    @Override
    public QueueObject clone(){
    	QueueObject clone = new QueueObject(entry, rankingCount);
    	clone.minDist = minDist;
    	clone.selfPruned = selfPruned;
    	clone.update1 = (ArrayList<QueueObject>)update1.clone();
    	clone.update2 = (ArrayList<QueueObject>)update2.clone();
    	return clone;
    }
}
