package experimentalcode.tobias.rknnjoin.structures;

import java.util.Arrays;

public class TopkList {
    public int max;
    private Double[] bestVals;
    public TopkList(int max) {
        this.max = max;
        bestVals = new Double[max];
        for(int i=0;i<bestVals.length;i++) {
            bestVals[i]=Double.POSITIVE_INFINITY;
        }
    }
    public void add(double newVal) {
//         if (newVal<0.0001) throw new NullPointerException();
        if(newVal<bestVals[max-1]) {
            bestVals[max-1]=newVal;
            Arrays.sort(bestVals);
        }
    }
    public double getLast() {
        return bestVals[max-1];
    }
    public void prettyPrint() {
        System.out.print("\n TopkList enthält folgende Elemente: ");
        for(int i=0;i<max;i++) {
            System.out.print(bestVals[i]);
        }
    }
    public boolean removeValue(double val) {
        for(int i=0;i<bestVals.length;i++) {
            if(bestVals[i]==val) {
                bestVals[i]=Double.POSITIVE_INFINITY;
                return true;
            }
        }
        return false;
    }
    public void removeValue(double val, int times) {
        for(int i=0;i<times;i++) {
            if (!removeValue(val)) break;
    }
    }

}

