package experimentalcode.tobias.rknnjoin.structures.buffer;

import java.util.TreeSet;

public class Buffer<B extends BufferElement<B>> {
	TreeSet<B> q;
	int maxSize;
	
	public Buffer(int maxSize) {
		q = new TreeSet<B>();
		this.maxSize = maxSize;
	}
	
	public boolean add(int pageID) {
		BufferElement<B> be = new BufferElement<B>(pageID);
		return this.add((B)be);
	}
	
	public boolean add(B newElement) {
		if (contains(newElement)) {
			q.remove(newElement);
			newElement.timestamp = System.currentTimeMillis();
			q.add(newElement);
			return false;
			
//			for(B b : q) {
//				if (b.pageID == newElement.pageID) {
//					b.timestamp = System.currentTimeMillis();
//				}
//			}
		}
		else if(q.size()<maxSize) {
			q.add(newElement);
			return true;
		}
		else {
			q.pollFirst();
			newElement.timestamp = System.currentTimeMillis();
			q.add(newElement);
			return true;
		}
	}
	
	public static void main(String[] args) {
		System.out.println();
		BufferElement a = new BufferElement(3);
		BufferElement b = new BufferElement(4);
		BufferElement c = new BufferElement(312);
		
		Buffer buffer = new Buffer(2);
		
		buffer.add(a);
		buffer.add(b);
		buffer.add(a);
		buffer.add(c);
	}
	
	private boolean contains(B b) {
		for(B be : q) {
			if (be.pageID == b.pageID) return true;
		}
		return false;
	}
	private void remove(B elem){
		for(B be : q) {
			if (be.pageID == elem.pageID) q.remove(be);
		}
	}
	
}
