package experimentalcode.tobias.rknnjoin.structures.buffer;


public class BufferElement<B extends BufferElement<B>> implements Comparable<B> {
    public double timestamp;
    public int pageID;
    
    
    public BufferElement(int pageID) {
        this.timestamp = System.currentTimeMillis();
        this.pageID = pageID;
    }

    /**
     * Returns 1 if this BufferElement is newer than target.
     * 
     * @param target
     * @return
     */
    public int compareTo(B target) {
        if (this.timestamp>target.timestamp) return 1;
        else if (this.timestamp<target.timestamp) return -1;
        else return 0;
    }
}
